#encoding:utf-8
from fastapi import FastAPI
from py2neo import Graph
from chatbot_graph import ChatBotGraph

app = FastAPI()


@app.get("/question")
async def read_item(question: str):
    handler = ChatBotGraph()
    answer = handler.chat_main(question)
    if(answer == "抱歉，我不知道"):
        return {
            "code": 404,
            "data": answer,
            "msg": "未找到答案"
        }
    return {
        "code": 200,
        "data": answer,
        "msg": None
    }

if __name__ == '__main__':
    
    # 连接到Neo4j数据库
    graph = Graph(
                "bolt://127.0.0.1:7687",
                # host="127.0.0.1",
                # http_port=7474,
                # user="neo4j",
                # password="123456"
                # http_port=7687,  # neo4j 服务器监听的端口号
                user="neo4j",  # 数据库user name，如果没有更改过，应该是neo4j
                password="123456")

    # 查询实体信息
    query = "MATCH (n) RETURN n"
    results = graph.run(query)

    # 将实体信息写入到TXT文件中
    with open("./dict/entity.txt", "w",encoding = 'utf-8') as f:
        for record in results:
            node = record["n"]
            f.write(f"{node['name']}\n")
    
    
    import uvicorn
    uvicorn.run(app=app,
                host="0.0.0.0",
                port=9998,
                workers=1)
