from py2neo import Graph

# Neo4j数据库连接信息
uri = "bolt://localhost:7687"  # Neo4j数据库URI
username = "neo4j"  # Neo4j数据库用户名
password = "123456"  # Neo4j数据库密码

# 连接Neo4j数据库
graph = Graph(uri, auth=(username, password))

query = "MATCH (n) RETURN n.name AS name"
result = graph.run(query)

# 将节点名称写入文件
with open("./dict/entity.txt", "w",encoding = 'utf-8') as file:
    for record in result:
        name = record["name"]
        file.write(name + "\n")

# 获取所有标签为"故障代码"的节点的name属性，并保存到txt文件中
def get_code():
    query = "MATCH (n:故障代码) RETURN n.name AS name"
    results = graph.run(query)
    names = [record["name"] for record in results]
    
    with open("./dict/code.txt", "w",encoding = 'utf-8') as file:
        for name in names:
            file.write(name + "\n")

    print("故障代码已保存到code.txt文件中。")

def get_fault():
    query = "MATCH (n:故障名称) RETURN n.name AS name"
    results = graph.run(query)
    names = [record["name"] for record in results]
    
    with open("./dict/fault.txt", "w",encoding = 'utf-8') as file:
        for name in names:
            file.write(name + "\n")

    print("故障名称已保存到fault.txt文件中。")

def get_phenomenon():
    query = "MATCH (n:故障现象) RETURN n.name AS name"
    results = graph.run(query)
    names = [record["name"] for record in results]
    
    with open("./dict/phenomenon.txt", "w",encoding = 'utf-8') as file:
        for name in names:
            file.write(name + "\n")

    print("故障现象已保存到phenomenon.txt文件中。")

def get_cause():
    query = "MATCH (n:故障原因) RETURN n.name AS name"
    results = graph.run(query)
    names = [record["name"] for record in results]
    
    with open("./dict/cause.txt", "w",encoding = 'utf-8') as file:
        for name in names:
            file.write(name + "\n")

    print("故障原因已保存到cause.txt文件中。")

def get_maintain():
    query = "MATCH (n:故障流程) RETURN n.name AS name"
    results = graph.run(query)
    names = [repr(record["name"]) for record in results]
    
    with open("./dict/maintain.txt", "w",encoding = 'utf-8') as file:
        for name in names:
            file.write(name + "\n")

    print("故障现象已保存到maintain.txt文件中。")

def get_level():
    query = "MATCH (n:故障等级) RETURN n.name AS name"
    results = graph.run(query)
    names = [record["name"] for record in results]
    
    with open("./dict/level.txt", "w",encoding = 'utf-8') as file:
        for name in names:
            file.write(name + "\n")

    print("故障等级已保存到level.txt文件中。")

# 从txt文件中读取节点的name属性
def read_nodes_from_file():
    with open("./dict/maintain.txt", "r",encoding = 'utf-8') as file:
        names = [eval(line.strip()) for line in file]

    return names

# 示例代码的执行
get_code()  # 获取并保存节点到txt文件中
get_cause()
get_fault()
get_level()
get_maintain()
get_phenomenon()
node_names = read_nodes_from_file()  # 从txt文件中读取节点名称
print("从txt文件中读取的节点名称：", node_names)