import json
import numpy as np
from mapping1.onehot_generate import onehot_generate
onehot_generate()
# 从文件读取关键词与one-hot编码的字典
with open("./mapping1/keyword_one_hot_dict.json", "r", encoding="utf-8") as json_file:
    keyword_one_hot_dict = json.load(json_file)

# 从文件读取故障现象词的向量字典
with open("./mapping1/phenomenon_vector_dict.json", "r", encoding="utf-8") as json_file:
    phenomenon_vector_dict = json.load(json_file)


def mapping(sentence: str):
    # 初始化词向量
    sentence_vector = np.zeros(len(keyword_one_hot_dict[list(keyword_one_hot_dict.keys())[0]]), dtype=np.int32)

    # 遍历关键词表，逐个查找关键词是否在句子中
    for word in keyword_one_hot_dict.keys():
        if word in sentence:
            keyword_vector = np.array(keyword_one_hot_dict[word], dtype=np.int32)
            sentence_vector += keyword_vector

    # 判断是否有对应的故障现象
    matched_phenomenon = None
    for phenomenon, vector in phenomenon_vector_dict.items():
        if np.array_equal(sentence_vector, vector):
            matched_phenomenon = phenomenon
            break

    # 输出结果
    if matched_phenomenon:
        return(matched_phenomenon)
    else:
        return None


# 输入句子
#sentence = "液压2系统压力正常"
#print(mapping(sentence))